﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
#Event: ButtonClick (Id As String)
#DesignerProperty: Key: LabelText, DisplayName: Label Text, FieldType: String, DefaultValue: Testing, Description: Text to display in the label
#DesignerProperty: Key: ButtonText, DisplayName: Button Text, FieldType: String, DefaultValue:, Description: Text to display in the button
#DesignerProperty: Key: Status, DisplayName: Scene Status, FieldType: String, DefaultValue: UNFILLED, List: UNFILLED | FILLED, Description: Status of button

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Private mId As String
	Private lbl_Label As B4XView
	Private btn_Button As B4XView
	Private mStatus As Int
	Type DummyListItemData(Id As String, LabelText As String, ButtonText As String, Status As Int)
	Public Const STATUS_UNFILLED = ListItemUtil.CATEGORY_STATUS_UNFILLED, STATUS_FILLED = ListItemUtil.CATEGORY_STATUS_FILLED As Int
	Private Const COLOUR_SELECTED = 0x73F9DB2F, COLOUR_UNSELECTED = xui.Color_Transparent As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
	InitClass(Props)
End Sub

Public Sub AddToParent(Parent As Object, Left As Int, Top As Int, Width As Int, Height As Int)
	mBase = xui.CreatePanel("mBase")
	Dim parentView As B4XView = Parent
	parentView.AddView(mBase, Left, Top, Width, Height)
	InitClass(Null)
End Sub

Public Sub LoadItemIntoPanel(Panel As B4XView, Data As DummyListItemData, Selected As Boolean) As ResumableSub
	If Selected Then
		Panel.Color = COLOUR_SELECTED
	Else
		Panel.Color = COLOUR_UNSELECTED
	End If
	AddToParent(Panel, 0, 0, Panel.Width, Panel.Height)
	Sleep(0)
	setData(Data)
	Return getHeight
End Sub

Private Sub InitClass(Props As Map)
	Sleep(0)
	mBase.LoadLayout("listitem_test")
	
	If Props <> Null And Props.IsInitialized Then
		setLabelText(Props.Get("LabelText"))
		setButtonText(Props.Get("ButtonText"))
		setStatus(GetStatusFromString(Props.Get("Status")))
	End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

Public Sub getId As String
	Return mId
End Sub

Public Sub setId(Id As String)
	mId = Id
End Sub

Public Sub getData As DummyListItemData
	Return ListItemUtil.CreateDummyListItemData(getId, getLabelText, getButtonText, getStatus)
End Sub

Public Sub setData(Data As DummyListItemData)
	If Data <> Null Then
		setId(Data.Id)
		setLabelText(Data.LabelText)
		setButtonText(Data.ButtonText)
		setStatus(Data.Status)
	End If
End Sub

Public Sub getHeight As Int
	Return lbl_Label.Height
End Sub

Public Sub getLabelText As String
	Return lbl_Label.Text
End Sub

Public Sub setLabelText(Text As String)
	lbl_Label.Text = Text
End Sub

Public Sub getButtonText As String
	Return btn_Button.Text
End Sub

Public Sub setButtonText(Text As String)
	btn_Button.Text = Text
End Sub

Public Sub getStatus As Int
	Return mStatus
End Sub

Public Sub setStatus(Status As Int)
	mStatus = Status
	RedrawStatusButton
End Sub

Private Sub GetStatusFromString(StatusString As String) As Int
	Select StatusString
		Case "UNFILLED": Return STATUS_UNFILLED
		Case Else: Return STATUS_FILLED
	End Select
End Sub

Private Sub RedrawStatusButton
	Dim button As Button = btn_Button
	button.Background = DummyStatusStatelistDrawable(mStatus)
	button.Enabled = DummyStatusClickable(mStatus)
End Sub

Private Sub DummyStatusStatelistDrawable(status As Int) As StateListDrawable
	Dim cornerRadius As Int = 4dip
	Dim normalCd, disabledCd, pressedCd As ColorDrawable
	Select status
		Case STATUS_UNFILLED
			normalCd.Initialize(0xFFF73B57, cornerRadius)
			disabledCd.Initialize(0x80F73B57, cornerRadius)
			pressedCd.Initialize(0xFFC90824, cornerRadius)
		Case Else
			normalCd.Initialize(0xFF999999, cornerRadius)
			disabledCd.Initialize(0x80999999, cornerRadius)
			pressedCd.Initialize(0xFFC90824, cornerRadius)
	End Select
	
	Dim sld As StateListDrawable
	sld.Initialize
	sld.AddState(sld.State_Enabled, normalCd)
	sld.AddState(sld.State_Disabled, disabledCd)
	sld.AddState(sld.State_Pressed, pressedCd)
	
	Return sld
End Sub

Private Sub DummyStatusClickable(status As Int) As Boolean
	Return status = STATUS_UNFILLED
End Sub

Sub btn_Button_Click
	If DummyStatusClickable(mStatus) And xui.SubExists(mCallBack, mEventName & "_ButtonClick", 1) Then
		CallSub2(mCallBack, mEventName & "_ButtonClick", mId)
	End If
End Sub